diff -urN qmail-1.03-vanilla/install-big.c qmail-1.03-md24/install-big.c
--- qmail-1.03-vanilla/install-big.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/install-big.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,3 +1,4 @@
+#include "install.h"
 #include "auto_qmail.h"
 #include "auto_split.h"
 #include "auto_uids.h"
@@ -145,115 +146,63 @@
   c(auto_qmail,"bin","pinq",auto_uido,auto_gidq,0755);
 
   c(auto_qmail,"man/man5","addresses.5",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat5","addresses.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man5","envelopes.5",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat5","envelopes.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man5","maildir.5",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat5","maildir.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man5","mbox.5",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat5","mbox.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man5","dot-qmail.5",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat5","dot-qmail.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man5","qmail-control.5",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat5","qmail-control.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man5","qmail-header.5",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat5","qmail-header.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man5","qmail-log.5",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat5","qmail-log.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man5","qmail-users.5",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat5","qmail-users.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man5","tcp-environ.5",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat5","tcp-environ.0",auto_uido,auto_gidq,0644);
 
   c(auto_qmail,"man/man7","forgeries.7",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat7","forgeries.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man7","qmail-limits.7",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat7","qmail-limits.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man7","qmail.7",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat7","qmail.0",auto_uido,auto_gidq,0644);
 
   c(auto_qmail,"man/man1","forward.1",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat1","forward.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man1","condredirect.1",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat1","condredirect.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man1","bouncesaying.1",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat1","bouncesaying.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man1","except.1",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat1","except.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man1","maildirmake.1",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat1","maildirmake.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man1","maildir2mbox.1",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat1","maildir2mbox.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man1","maildirwatch.1",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat1","maildirwatch.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man1","mailsubj.1",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat1","mailsubj.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man1","qreceipt.1",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat1","qreceipt.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man1","qbiff.1",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat1","qbiff.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man1","preline.1",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat1","preline.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man1","tcp-env.1",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat1","tcp-env.0",auto_uido,auto_gidq,0644);
 
   c(auto_qmail,"man/man8","qmail-local.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","qmail-local.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man8","qmail-lspawn.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","qmail-lspawn.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man8","qmail-getpw.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","qmail-getpw.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man8","qmail-remote.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","qmail-remote.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man8","qmail-rspawn.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","qmail-rspawn.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man8","qmail-clean.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","qmail-clean.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man8","qmail-send.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","qmail-send.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man8","qmail-start.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","qmail-start.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man8","splogger.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","splogger.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man8","qmail-queue.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","qmail-queue.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man8","qmail-inject.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","qmail-inject.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man8","qmail-showctl.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","qmail-showctl.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man8","qmail-newmrh.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","qmail-newmrh.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man8","qmail-newu.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","qmail-newu.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man8","qmail-pw2u.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","qmail-pw2u.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man8","qmail-qread.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","qmail-qread.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man8","qmail-qstat.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","qmail-qstat.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man8","qmail-tcpok.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","qmail-tcpok.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man8","qmail-tcpto.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","qmail-tcpto.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man8","qmail-pop3d.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","qmail-pop3d.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man8","qmail-popup.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","qmail-popup.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man8","qmail-qmqpc.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","qmail-qmqpc.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man8","qmail-qmqpd.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","qmail-qmqpd.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man8","qmail-qmtpd.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","qmail-qmtpd.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man8","qmail-smtpd.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","qmail-smtpd.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man8","qmail-command.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","qmail-command.0",auto_uido,auto_gidq,0644);
 
   c(auto_qmail,"bin","dot-forward",auto_uido,auto_gidq,0755);
 
   c(auto_qmail,"man/man1","dot-forward.1",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat1","dot-forward.0",auto_uido,auto_gidq,0644);
 
   d(auto_qmail,"doc/fastforward",auto_uido,auto_gidq,0755);
 
@@ -275,11 +224,4 @@
   c(auto_qmail,"man/man1","setmaillist.1",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man1","newinclude.1",auto_uido,auto_gidq,0644);
 
-  c(auto_qmail,"man/cat1","fastforward.0",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat1","printforward.0",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat1","setforward.0",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat1","newaliases.0",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat1","printmaillist.0",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat1","setmaillist.0",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat1","newinclude.0",auto_uido,auto_gidq,0644);
 }
diff -urN qmail-1.03-vanilla/install.c qmail-1.03-md24/install.c
--- qmail-1.03-vanilla/install.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/install.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,9 +1,11 @@
+#include "install.h"
 #include "substdio.h"
 #include "strerr.h"
 #include "error.h"
 #include "open.h"
 #include "readwrite.h"
 #include "exit.h"
+#include "fifo.h"
 
 extern void hier();
 
@@ -152,7 +154,7 @@
     strerr_die6sys(111,FATAL,"unable to chmod ",home,"/",file,": ");
 }
 
-void main()
+int main()
 {
   fdsourcedir = open_read(".");
   if (fdsourcedir == -1)
diff -urN qmail-1.03-vanilla/install.h qmail-1.03-md24/install.h
--- qmail-1.03-vanilla/install.h	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-md24/install.h	2007-07-19 20:56:22.000000000 +0200
@@ -0,0 +1,11 @@
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <unistd.h>
+
+extern void hier();
+extern void perm();
+extern void h();
+extern void d();
+extern void p();
+extern void c();
+extern void z();
diff -urN qmail-1.03-vanilla/instcheck.c qmail-1.03-md24/instcheck.c
--- qmail-1.03-vanilla/instcheck.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/instcheck.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,5 +1,6 @@
 #include <sys/types.h>
 #include <sys/stat.h>
+#include <unistd.h>
 #include "strerr.h"
 #include "error.h"
 #include "readwrite.h"
@@ -101,7 +102,7 @@
   perm("",home,"/",file,S_IFREG,uid,gid,mode);
 }
 
-void main()
+int main()
 {
   hier();
   _exit(0);
diff -urN qmail-1.03-vanilla/ipalloc.h qmail-1.03-md24/ipalloc.h
--- qmail-1.03-vanilla/ipalloc.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/ipalloc.h	2007-07-19 20:56:22.000000000 +0200
@@ -2,8 +2,7 @@
 #define IPALLOC_H
 
 #include "ip.h"
-
-struct ip_mx { struct ip_address ip; int pref; } ;
+struct ip_mx { struct ip_address ip; int pref; char *fqdn; } ;
 
 #include "gen_alloc.h"
 
diff -urN qmail-1.03-vanilla/ipme.c qmail-1.03-md24/ipme.c
--- qmail-1.03-vanilla/ipme.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/ipme.c	2007-07-19 20:56:22.000000000 +0200
@@ -4,6 +4,7 @@
 #include <sys/ioctl.h>
 #include <sys/socket.h>
 #include <net/if.h>
+#include <unistd.h>
 #include <netinet/in.h>
 #ifndef SIOCGIFCONF /* whatever works */
 #include <sys/sockio.h>
@@ -46,6 +47,11 @@
   ipme.len = 0;
   ix.pref = 0;
  
+  /* 0.0.0.0 is a special address which always refers to 
+   * "this host, this network", according to RFC 1122, Sec. 3.2.1.3a.
+  */
+  byte_copy(&ix.ip,4,"\0\0\0\0");
+  if (!ipalloc_append(&ipme,&ix)) { return 0; }
   if ((s = socket(AF_INET,SOCK_STREAM,0)) == -1) return -1;
  
   len = 256;
diff -urN qmail-1.03-vanilla/ipmeprint.c qmail-1.03-md24/ipmeprint.c
--- qmail-1.03-vanilla/ipmeprint.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/ipmeprint.c	2007-07-19 20:56:22.000000000 +0200
@@ -6,7 +6,7 @@
 
 char temp[IPFMT];
 
-void main()
+int main()
 {
  int j;
  switch(ipme_init())
diff -urN qmail-1.03-vanilla/maildir2mbox.c qmail-1.03-md24/maildir2mbox.c
--- qmail-1.03-vanilla/maildir2mbox.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/maildir2mbox.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,3 +1,5 @@
+#include <sys/types.h>
+#include <unistd.h>
 #include "readwrite.h"
 #include "prioq.h"
 #include "env.h"
@@ -33,7 +35,7 @@
 
 void die_nomem() { strerr_die2x(111,FATAL,"out of memory"); }
 
-void main()
+int main()
 {
  substdio ssin;
  substdio ssout;
diff -urN qmail-1.03-vanilla/maildir.c qmail-1.03-md24/maildir.c
--- qmail-1.03-vanilla/maildir.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/maildir.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,5 +1,6 @@
 #include <sys/types.h>
 #include <sys/stat.h>
+#include <unistd.h>
 #include "prioq.h"
 #include "env.h"
 #include "stralloc.h"
@@ -36,8 +37,7 @@
  dir = opendir("tmp");
  if (!dir) return;
 
- while (d = readdir(dir))
-  {
+ while ((d = readdir(dir))) {
    if (d->d_name[0] == '.') continue;
    if (!stralloc_copys(tmpname,"tmp/")) break;
    if (!stralloc_cats(tmpname,d->d_name)) break;
@@ -45,7 +45,7 @@
    if (stat(tmpname->s,&st) == 0)
      if (time > st.st_atime + 129600)
        unlink(tmpname->s);
-  }
+ }
  closedir(dir);
 }
 
@@ -65,8 +65,7 @@
  if (!dir)
    STRERR_SYS3(-1,maildir_scan_err,"unable to scan $MAILDIR/",subdir,": ")
 
- while (d = readdir(dir))
-  {
+ while ((d = readdir(dir))) {
    if (d->d_name[0] == '.') continue;
    pos = filenames->len;
    if (!stralloc_cats(filenames,subdir)) break;
@@ -80,7 +79,7 @@
        pe.id = pos;
        if (!prioq_insert(pq,&pe)) break;
       }
-  }
+ }
 
  closedir(dir);
  if (d) STRERR_SYS3(-1,maildir_scan_err,"unable to read $MAILDIR/",subdir,": ")
@@ -95,7 +94,6 @@
 {
  struct prioq_elt pe;
  datetime_sec time;
- int r;
 
  if (!stralloc_copys(filenames,"")) return 0;
  while (prioq_min(pq,&pe)) prioq_delmin(pq);
diff -urN qmail-1.03-vanilla/maildirmake.c qmail-1.03-md24/maildirmake.c
--- qmail-1.03-vanilla/maildirmake.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/maildirmake.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,9 +1,11 @@
+#include <sys/types.h>
+#include <unistd.h>
 #include "strerr.h"
 #include "exit.h"
 
 #define FATAL "maildirmake: fatal: "
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
diff -urN qmail-1.03-vanilla/maildirwatch.c qmail-1.03-md24/maildirwatch.c
--- qmail-1.03-vanilla/maildirwatch.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/maildirwatch.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,3 +1,5 @@
+#include <sys/types.h>
+#include <unistd.h>
 #include "getln.h"
 #include "substdio.h"
 #include "subfd.h"
@@ -58,7 +60,7 @@
 char inbuf[SUBSTDIO_INSIZE];
 substdio ssin;
 
-void main()
+int main()
 {
  struct prioq_elt pe;
  int fd;
diff -urN qmail-1.03-vanilla/Makefile qmail-1.03-md24/Makefile
--- qmail-1.03-vanilla/Makefile	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/Makefile	2007-08-12 10:09:00.000000000 +0200
@@ -408,10 +408,10 @@
 
 dnscname: \
 load dnscname.o dns.o dnsdoe.o ip.o ipalloc.o stralloc.a alloc.a \
-substdio.a error.a str.a fs.a dns.lib socket.lib
+substdio.a error.a str.a fs.a strsalloc.o dns.lib socket.lib
 	./load dnscname dns.o dnsdoe.o ip.o ipalloc.o stralloc.a \
-	alloc.a substdio.a error.a str.a fs.a  `cat dns.lib` `cat \
-	socket.lib`
+	alloc.a substdio.a error.a str.a fs.a strsalloc.o \
+	`cat dns.lib` `cat socket.lib`
 
 dnscname.o: \
 compile dnscname.c substdio.h subfd.h substdio.h stralloc.h \
@@ -424,10 +424,10 @@
 
 dnsfq: \
 load dnsfq.o dns.o dnsdoe.o ip.o ipalloc.o stralloc.a alloc.a \
-substdio.a error.a str.a fs.a dns.lib socket.lib
+substdio.a error.a str.a fs.a strsalloc.o dns.lib socket.lib
 	./load dnsfq dns.o dnsdoe.o ip.o ipalloc.o stralloc.a \
-	alloc.a substdio.a error.a str.a fs.a  `cat dns.lib` `cat \
-	socket.lib`
+	alloc.a substdio.a error.a str.a fs.a strsalloc.o `cat dns.lib` \
+	`cat socket.lib`
 
 dnsfq.o: \
 compile dnsfq.c substdio.h subfd.h substdio.h stralloc.h gen_alloc.h \
@@ -436,10 +436,10 @@
 
 dnsip: \
 load dnsip.o dns.o dnsdoe.o ip.o ipalloc.o stralloc.a alloc.a \
-substdio.a error.a str.a fs.a dns.lib socket.lib
+substdio.a error.a str.a fs.a strsalloc.o dns.lib socket.lib
 	./load dnsip dns.o dnsdoe.o ip.o ipalloc.o stralloc.a \
-	alloc.a substdio.a error.a str.a fs.a  `cat dns.lib` `cat \
-	socket.lib`
+	alloc.a substdio.a error.a str.a fs.a strsalloc.o \
+	`cat dns.lib` `cat socket.lib`
 
 dnsip.o: \
 compile dnsip.c substdio.h subfd.h substdio.h stralloc.h gen_alloc.h \
@@ -448,10 +448,10 @@
 
 dnsmxip: \
 load dnsmxip.o dns.o dnsdoe.o ip.o ipalloc.o now.o stralloc.a alloc.a \
-substdio.a error.a str.a fs.a dns.lib socket.lib
+substdio.a error.a str.a fs.a strsalloc.o dns.lib socket.lib
 	./load dnsmxip dns.o dnsdoe.o ip.o ipalloc.o now.o \
-	stralloc.a alloc.a substdio.a error.a str.a fs.a  `cat \
-	dns.lib` `cat socket.lib`
+	stralloc.a alloc.a substdio.a error.a str.a fs.a strsalloc.o \
+	`cat dns.lib` `cat socket.lib`
 
 dnsmxip.o: \
 compile dnsmxip.c substdio.h subfd.h substdio.h stralloc.h \
@@ -461,10 +461,10 @@
 
 dnsptr: \
 load dnsptr.o dns.o dnsdoe.o ip.o ipalloc.o stralloc.a alloc.a \
-substdio.a error.a str.a fs.a dns.lib socket.lib
+substdio.a error.a str.a fs.a strsalloc.o dns.lib socket.lib
 	./load dnsptr dns.o dnsdoe.o ip.o ipalloc.o stralloc.a \
-	alloc.a substdio.a error.a str.a fs.a  `cat dns.lib` `cat \
-	socket.lib`
+	alloc.a substdio.a error.a str.a fs.a strsalloc.o \
+	`cat dns.lib` `cat socket.lib`
 
 dnsptr.o: \
 compile dnsptr.c substdio.h subfd.h substdio.h stralloc.h gen_alloc.h \
@@ -1269,9 +1269,11 @@
 qmail-pop3d: \
 load qmail-pop3d.o commands.o case.a timeoutread.o timeoutwrite.o \
 maildir.o prioq.o now.o env.a strerr.a sig.a open.a getln.a \
+out_log.o control.o base64.o auto_qmail.o \
 stralloc.a alloc.a substdio.a error.a str.a fs.a socket.lib
 	./load qmail-pop3d commands.o case.a timeoutread.o \
 	timeoutwrite.o maildir.o prioq.o now.o env.a strerr.a sig.a \
+	out_log.o control.o base64.o auto_qmail.o \
 	open.a getln.a stralloc.a alloc.a substdio.a error.a str.a \
 	fs.a  `cat socket.lib`
 
@@ -1288,11 +1290,13 @@
 
 qmail-popup: \
 load qmail-popup.o commands.o timeoutread.o timeoutwrite.o now.o \
+control.o out_log.o qmail-sasl.o base64.o env.a getln.a open.a \
 case.a fd.a sig.a wait.a stralloc.a alloc.a substdio.a error.a str.a \
-fs.a socket.lib
-	./load qmail-popup commands.o timeoutread.o timeoutwrite.o \
-	now.o case.a fd.a sig.a wait.a stralloc.a alloc.a \
-	substdio.a error.a str.a fs.a  `cat socket.lib`
+fs.a socket.lib auto_qmail.o sha1.o hmac_sha1.o ucspitls.o
+	./load qmail-popup commands.o timeoutread.o timeoutwrite.o ucspitls.o \
+	control.o out_log.o qmail-sasl.o base64.o env.a getln.a open.a \
+	now.o case.a fd.a sig.a wait.a stralloc.a alloc.a auto_qmail.o \
+	substdio.a error.a str.a fs.a sha1.o hmac_sha1.o `cat socket.lib`
 
 qmail-popup.0: \
 qmail-popup.8
@@ -1368,13 +1372,15 @@
 
 qmail-qmtpd: \
 load qmail-qmtpd.o rcpthosts.o control.o constmap.o received.o \
+realrcptto.o auto_break.o auto_usera.o \
 date822fmt.o now.o qmail.o cdb.a fd.a wait.a datetime.a open.a \
 getln.a sig.a case.a env.a stralloc.a alloc.a substdio.a error.a \
-str.a fs.a auto_qmail.o
+str.a fs.a auto_qmail.o 
 	./load qmail-qmtpd rcpthosts.o control.o constmap.o \
+	realrcptto.o auto_break.o auto_usera.o \
 	received.o date822fmt.o now.o qmail.o cdb.a fd.a wait.a \
 	datetime.a open.a getln.a sig.a case.a env.a stralloc.a \
-	alloc.a substdio.a error.a str.a fs.a auto_qmail.o 
+	alloc.a substdio.a error.a str.a fs.a auto_qmail.o
 
 qmail-qmtpd.0: \
 qmail-qmtpd.8
@@ -1421,11 +1427,13 @@
 qmail-queue: \
 load qmail-queue.o triggerpull.o fmtqfn.o now.o date822fmt.o \
 datetime.a seek.a ndelay.a open.a sig.a alloc.a substdio.a error.a \
-str.a fs.a auto_qmail.o auto_split.o auto_uids.o
+str.a fs.a auto_qmail.o auto_split.o auto_uids.o control.o stralloc.a \
+constmap.o open.a getln.a case.a alloc.a
 	./load qmail-queue triggerpull.o fmtqfn.o now.o \
 	date822fmt.o datetime.a seek.a ndelay.a open.a sig.a \
 	alloc.a substdio.a error.a str.a fs.a auto_qmail.o \
-	auto_split.o auto_uids.o 
+	auto_split.o auto_uids.o control.o stralloc.a constmap.o \
+	open.a getln.a case.a alloc.a
 
 qmail-queue.0: \
 qmail-queue.8
@@ -1439,35 +1447,38 @@
 
 qmail-remote: \
 load qmail-remote.o control.o constmap.o timeoutread.o timeoutwrite.o \
-timeoutconn.o tcpto.o now.o dns.o ip.o ipalloc.o ipme.o quote.o \
+timeoutconn.o tcpto.o now.o dns.o ip.o strsalloc.o ipalloc.o ipme.o quote.o \
 ndelay.a case.a sig.a open.a lock.a seek.a getln.a stralloc.a alloc.a \
+md5.o sha1.o ripemd.o hmac_ripemd.o hmac_md5.o hmac_sha1.o base64.o \
 substdio.a error.a str.a fs.a auto_qmail.o dns.lib socket.lib
 	./load qmail-remote control.o constmap.o timeoutread.o \
-	timeoutwrite.o timeoutconn.o tcpto.o now.o dns.o ip.o \
-	ipalloc.o ipme.o quote.o ndelay.a case.a sig.a open.a \
+	timeoutwrite.o timeoutconn.o tcpto.o now.o dns.o ip.o strsalloc.o \
+	md5.o sha1.o ripemd.o hmac_ripemd.o hmac_md5.o hmac_sha1.o \
+	ipalloc.o ipme.o quote.o ndelay.a case.a sig.a open.a base64.o \
 	lock.a seek.a getln.a stralloc.a alloc.a substdio.a error.a \
-	str.a fs.a auto_qmail.o  `cat dns.lib` `cat socket.lib`
+	str.a fs.a auto_qmail.o `cat dns.lib` `cat socket.lib`
 
 qmail-remote.0: \
 qmail-remote.8
 	nroff -man qmail-remote.8 > qmail-remote.0
 
 qmail-remote.o: \
-compile qmail-remote.c sig.h stralloc.h gen_alloc.h substdio.h \
+compile qmail-remote.c sig.h stralloc.h gen_alloc.h substdio.h control.h \
 subfd.h substdio.h scan.h case.h error.h auto_qmail.h control.h dns.h \
-alloc.h quote.h ip.h ipalloc.h ip.h gen_alloc.h ipme.h ip.h ipalloc.h \
-gen_alloc.h gen_allocdefs.h str.h now.h datetime.h exit.h constmap.h \
-tcpto.h readwrite.h timeoutconn.h timeoutread.h timeoutwrite.h
+alloc.h quote.h ip.h ipalloc.h strsalloc.h ip.h gen_alloc.h ipme.h ip.h \
+ipalloc.h strsalloc.h gen_alloc.h gen_allocdefs.h str.h now.h datetime.h \
+exit.h constmap.h tcpto.h readwrite.h timeoutconn.h timeoutread.h \
+timeoutwrite.h
 	./compile qmail-remote.c
 
 qmail-rspawn: \
 load qmail-rspawn.o spawn.o tcpto_clean.o now.o coe.o sig.a open.a \
 seek.a lock.a wait.a fd.a stralloc.a alloc.a substdio.a error.a str.a \
-auto_qmail.o auto_uids.o auto_spawn.o
+auto_qmail.o auto_uids.o auto_spawn.o fmt_ulong.o
 	./load qmail-rspawn spawn.o tcpto_clean.o now.o coe.o \
 	sig.a open.a seek.a lock.a wait.a fd.a stralloc.a alloc.a \
 	substdio.a error.a str.a auto_qmail.o auto_uids.o \
-	auto_spawn.o 
+	auto_spawn.o fmt_ulong.o
 
 qmail-rspawn.0: \
 qmail-rspawn.8
@@ -1483,12 +1494,12 @@
 trigger.o fmtqfn.o quote.o now.o readsubdir.o qmail.o date822fmt.o \
 datetime.a case.a ndelay.a getln.a wait.a seek.a fd.a sig.a open.a \
 lock.a stralloc.a alloc.a substdio.a error.a str.a fs.a auto_qmail.o \
-auto_split.o
+auto_split.o env.a
 	./load qmail-send qsutil.o control.o constmap.o newfield.o \
 	prioq.o trigger.o fmtqfn.o quote.o now.o readsubdir.o \
 	qmail.o date822fmt.o datetime.a case.a ndelay.a getln.a \
 	wait.a seek.a fd.a sig.a open.a lock.a stralloc.a alloc.a \
-	substdio.a error.a str.a fs.a auto_qmail.o auto_split.o 
+	substdio.a error.a str.a fs.a auto_qmail.o auto_split.o env.a
 
 qmail-send.0: \
 qmail-send.8
@@ -1533,15 +1544,21 @@
 
 qmail-smtpd: \
 load qmail-smtpd.o rcpthosts.o commands.o timeoutread.o \
+out_log.o timeoutconn.o qmail-p0f.o qmail-sasl.o base64.o dns.o \
+realrcptto.o strsalloc.o ndelay.a auto_break.o auto_usera.o \
+sha1.o hmac_sha1.o ucspitls.o \
 timeoutwrite.o ip.o ipme.o ipalloc.o control.o constmap.o received.o \
 date822fmt.o now.o qmail.o cdb.a fd.a wait.a datetime.a getln.a \
 open.a sig.a case.a env.a stralloc.a alloc.a substdio.a error.a str.a \
 fs.a auto_qmail.o socket.lib
 	./load qmail-smtpd rcpthosts.o commands.o timeoutread.o \
+	out_log.o timeoutconn.o qmail-p0f.o qmail-sasl.o base64.o \
+	dns.o realrcptto.o strsalloc.o ndelay.a auto_break.o \
+	auto_usera.o sha1.o hmac_sha1.o ucspitls.o  \
 	timeoutwrite.o ip.o ipme.o ipalloc.o control.o constmap.o \
 	received.o date822fmt.o now.o qmail.o cdb.a fd.a wait.a \
 	datetime.a getln.a open.a sig.a case.a env.a stralloc.a \
-	alloc.a substdio.a error.a str.a fs.a auto_qmail.o  `cat \
+	alloc.a substdio.a error.a str.a fs.a auto_qmail.o `cat \
 	socket.lib`
 
 qmail-smtpd.0: \
@@ -1914,10 +1931,10 @@
 str.a: \
 makelib str_len.o str_diff.o str_diffn.o str_cpy.o str_chr.o \
 str_rchr.o str_start.o byte_chr.o byte_rchr.o byte_diff.o byte_copy.o \
-byte_cr.o byte_zero.o
+byte_cr.o byte_zero.o str_cpyb.o
 	./makelib str.a str_len.o str_diff.o str_diffn.o str_cpy.o \
 	str_chr.o str_rchr.o str_start.o byte_chr.o byte_rchr.o \
-	byte_diff.o byte_copy.o byte_cr.o byte_zero.o
+	byte_diff.o byte_copy.o byte_cr.o byte_zero.o str_cpyb.o
 
 str_chr.o: \
 compile str_chr.c str.h
@@ -2066,9 +2083,10 @@
 
 tcp-env: \
 load tcp-env.o dns.o remoteinfo.o timeoutread.o timeoutwrite.o \
+strsalloc.o \
 timeoutconn.o ip.o ipalloc.o case.a ndelay.a sig.a env.a getopt.a \
 stralloc.a alloc.a substdio.a error.a str.a fs.a dns.lib socket.lib
-	./load tcp-env dns.o remoteinfo.o timeoutread.o \
+	./load tcp-env dns.o remoteinfo.o timeoutread.o strsalloc.o \
 	timeoutwrite.o timeoutconn.o ip.o ipalloc.o case.a ndelay.a \
 	sig.a env.a getopt.a stralloc.a alloc.a substdio.a error.a \
 	str.a fs.a  `cat dns.lib` `cat socket.lib`
@@ -2139,3 +2157,60 @@
 wait_pid.o: \
 compile wait_pid.c error.h haswaitp.h
 	./compile wait_pid.c
+
+# new targets
+strsalloc.o: \
+compile strsalloc.c
+	./compile strsalloc.c
+
+str_cpyb.o: \
+compile str_cpyb.c
+	./compile str_cpyb.c
+
+md5.o: \
+compile md5.c md5.h
+	./compile md5.c
+
+sha1.o: \
+compile sha1.c sha1.h
+	./compile sha1.c
+
+ripemd.o: \
+compile ripemd.c ripemd.h
+	./compile ripemd.c
+
+hmac_ripemd.o: \
+compile hmac_ripemd.c hmac.h
+	./compile hmac_ripemd.c
+
+hmac_md5.o: \
+compile hmac_md5.c hmac.h
+	./compile hmac_md5.c
+
+hmac_sha1.o: \
+compile hmac_sha1.c hmac.h
+	./compile hmac_sha1.c
+
+base64.o: \
+compile base64.c base64.h
+	./compile base64.c
+
+out_log.o: \
+compile out_log.c out_log.h
+	./compile out_log.c
+
+qmail-sasl.o: \
+compile qmail-sasl.c qmail-sasl.h
+	./compile qmail-sasl.c
+
+realrcptto.o: \
+compile realrcptto.c
+	./compile realrcptto.c
+
+qmail-p0f.o: \
+compile qmail-p0f.c qmail-p0f.h
+	./compile qmail-p0f.c
+
+ucspitls.o: \
+compile ucspitls.c ucspitls.h
+	./compile ucspitls.c
